
set echo on
set serveroutput on

DECLARE

   r_dequeue_options DBMS_AQ.DEQUEUE_OPTIONS_T;
   nt_msg_properties DBMS_AQ.MESSAGE_PROPERTIES_ARRAY_T;
   nt_payloads       demo_aq_array_ntt;
   nt_msg_ids        DBMS_AQ.MSGID_ARRAY_T;
   v_dequeued_cnt    PLS_INTEGER;
   v_dequeue_batch   PLS_INTEGER := 500;
   v_continue        BOOLEAN := TRUE;

   x_timeout EXCEPTION;
   PRAGMA EXCEPTION_INIT(x_timeout, -25228);

BEGIN

   /* Prepare collections... */
   nt_payloads := demo_aq_array_ntt();
   nt_payloads.EXTEND(v_dequeue_batch);
   nt_msg_properties := DBMS_AQ.MESSAGE_PROPERTIES_ARRAY_T();
   nt_msg_properties.EXTEND(v_dequeue_batch);
   nt_msg_ids := DBMS_AQ.MSGID_ARRAY_T();

   /* Set a 5 second timeout for the dequeue... */
   r_dequeue_options.wait := 5;

   /* Dequeue all messages in batches... */
   WHILE v_continue LOOP

      BEGIN

         v_dequeued_cnt := DBMS_AQ.DEQUEUE_ARRAY(
                              queue_name               => 'demo_aq_array_q',
                              dequeue_options          => r_dequeue_options,
                              array_size               => v_dequeue_batch,
                              message_properties_array => nt_msg_properties,
                              payload_array            => nt_payloads,
                              msgid_array              => nt_msg_ids
                              );

         DBMS_OUTPUT.PUT_LINE(
            'Dequeued [' || TO_CHAR(v_dequeued_cnt) || '] messages.'
            );

         INSERT INTO demo_aq_array_mt
         SELECT nt.message, SYSTIMESTAMP
         FROM   TABLE(nt_payloads) nt;

         DBMS_OUTPUT.PUT_LINE(
            'Inserted [' || TO_CHAR(SQL%ROWCOUNT) || '] messages.'
            );

         /* Handle exit scenario one from the notes above... */
         v_continue := (v_dequeued_cnt = v_dequeue_batch);

         /* Commit the batch... */
         COMMIT;

      EXCEPTION

         /* Handle exit scenario two from the notes above... */
         WHEN x_timeout THEN
            DBMS_OUTPUT.PUT_LINE(
               'No more messages to dequeue.'
               );
            v_continue := FALSE;

      END;

   END LOOP;

END;
/
