
set serveroutput on
set echo on
set timing on

DECLARE

   r_enqueue_options DBMS_AQ.ENQUEUE_OPTIONS_T;
   r_msg_properties  DBMS_AQ.MESSAGE_PROPERTIES_T;
   nt_msg_properties DBMS_AQ.MESSAGE_PROPERTIES_ARRAY_T;
   nt_payloads       demo_aq_array_ntt;
   nt_msg_ids        DBMS_AQ.MSGID_ARRAY_T;
   v_enqueued_cnt    PLS_INTEGER;

BEGIN

   /* Initialise the collections... */
   nt_payloads := demo_aq_array_ntt();
   nt_msg_properties := DBMS_AQ.MESSAGE_PROPERTIES_ARRAY_T();
   nt_msg_ids := DBMS_AQ.MSGID_ARRAY_T();

   /* Load up 7500 arbitrary messages... */
   FOR i IN 1 .. 7500 LOOP

      nt_payloads.EXTEND;
      nt_payloads(nt_payloads.LAST) := demo_aq_array_ot(
                                          'Message number ' || TO_CHAR(i)
                                          );

      nt_msg_properties.EXTEND;
      nt_msg_properties(nt_msg_properties.LAST) := r_msg_properties;

   END LOOP;

   /* Enqueue the messages in a single transaction... */
   v_enqueued_cnt := DBMS_AQ.ENQUEUE_ARRAY(
                        queue_name               => 'demo_aq_array_q',
                        enqueue_options          => r_enqueue_options,
                        array_size               => nt_payloads.COUNT,
                        message_properties_array => nt_msg_properties,
                        payload_array            => nt_payloads,
                        msgid_array              => nt_msg_ids
                        );
   COMMIT;

   DBMS_OUTPUT.PUT_LINE(
      'Enqueued [' || TO_CHAR(v_enqueued_cnt) || '] messages.'
      );

END;
/

