
set echo on
set serveroutput on
set timing on

DECLARE

   r_dequeue_options DBMS_AQ.DEQUEUE_OPTIONS_T;
   nt_msg_properties DBMS_AQ.MESSAGE_PROPERTIES_ARRAY_T;
   nt_payloads       demo_aq_array_ntt;
   nt_msg_ids        DBMS_AQ.MSGID_ARRAY_T;
   v_dequeued_cnt    PLS_INTEGER;
   v_dequeue_batch   PLS_INTEGER := 2500;

BEGIN

   /* Prepare collections... */
   nt_payloads := demo_aq_array_ntt();
   nt_payloads.EXTEND(v_dequeue_batch);
   nt_msg_properties := DBMS_AQ.MESSAGE_PROPERTIES_ARRAY_T();
   nt_msg_properties.EXTEND(v_dequeue_batch);
   nt_msg_ids := DBMS_AQ.MSGID_ARRAY_T();

   /* Dequeue 2,500 messages... */
   v_dequeued_cnt := DBMS_AQ.DEQUEUE_ARRAY(
                        queue_name               => 'demo_aq_array_q',
                        dequeue_options          => r_dequeue_options,
                        array_size               => v_dequeue_batch,
                        message_properties_array => nt_msg_properties,
                        payload_array            => nt_payloads,
                        msgid_array              => nt_msg_ids
                        );

   DBMS_OUTPUT.PUT_LINE(
      'Dequeued [' || TO_CHAR(v_dequeued_cnt) || '] messages.'
      );

   COMMIT;

END;
/
